//
//  LLDragCollectionViewCell.m
//  拖拽
//
//  Created by lijianli on 2017/3/18.
//  Copyright © 2017年 lijianli. All rights reserved.
//

#import "LLDragCollectionViewCell.h"
#import "LLDragDeleteBtn.h"
#import "Header.h"
#import "LLDragDataSource.h"

#define kDeleteH 10


@interface LLDragCollectionViewCell ()<UIGestureRecognizerDelegate>
@property(nonatomic, strong)UILabel *titleLabel;
@property(nonatomic, strong)LLDragDeleteBtn *deleteBtn;
@property(nonatomic, strong)UIView *backgrondView;

@end

@implementation LLDragCollectionViewCell
-(instancetype)initWithFrame:(CGRect)frame{
    if ([super initWithFrame:frame]) {
        self.backgroundColor = [UIColor whiteColor];
        [self setUI];
    }
    return self;
}
-(void)setUI{
    
    UILongPressGestureRecognizer *longPress = [[UILongPressGestureRecognizer alloc]initWithTarget:self action:@selector(gestureAtion:)];
    longPress.delegate = self;
    [self addGestureRecognizer:longPress];
    
    UIPanGestureRecognizer *pan = [[UIPanGestureRecognizer alloc]initWithTarget:self action:@selector(gestureAtion:)];
    pan.delegate = self;
    [self addGestureRecognizer:pan];
    
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(gestureAtion:)];
    [self addGestureRecognizer:tap];
    
    self.titleLabel = [[UILabel alloc]init];
//    _titleLabel.frame = CGRectMake(0, 0, self.bounds.size.width - kDeleteH, self.bounds.size.height - kDeleteH);
//    _titleLabel.center = self.center;
    _titleLabel.font     = [UIFont systemFontOfSize:12];
    _titleLabel.textColor = kBlackColor;
    _titleLabel.layer.masksToBounds = YES;
    _titleLabel.layer.borderWidth = 0.75f;
    _titleLabel.layer.borderColor = kGrayColor.CGColor;
    _titleLabel.textAlignment = NSTextAlignmentCenter;
    [self.contentView addSubview:_titleLabel];
    
    self.deleteBtn = [LLDragDeleteBtn buttonWithType:UIButtonTypeCustom];
    _deleteBtn.backgroundColor = [UIColor grayColor];
    _deleteBtn.frame = CGRectMake(0, 0, kDeleteH, kDeleteH);
    [_deleteBtn addTarget:self action:@selector(deleteAction:) forControlEvents:UIControlEventTouchUpInside];
    [self.contentView addSubview:_deleteBtn];
    
}
-(void)showDeleteBtn{
    _deleteBtn.hidden = NO;
}
-(void)setTitleName:(NSString *)titleName{
    _titleName = titleName;
    _titleLabel.text = _titleName;
    _deleteBtn.hidden = ![LLDragDataSource shareInstancetype].isEditing;
    _titleLabel.frame = CGRectMake(0, 0, self.bounds.size.width, self.bounds.size.height);
    _titleLabel.center = CGPointMake(self.bounds.size.width * 0.5, self.bounds.size.height * 0.5);
    _titleLabel.layer.cornerRadius = _titleLabel.bounds.size.height / 2.0f;
    
}
-(BOOL)gestureRecognizerShouldBegin:(UIGestureRecognizer *)gestureRecognizer{
    if ([gestureRecognizer isKindOfClass:[UIPanGestureRecognizer class]] && ![[LLDragDataSource shareInstancetype]isEditing]) {
        return NO;
    }
    return YES;
}
-(void)deleteAction:(UIButton *)sender{
    if (self.delegate && [self.delegate respondsToSelector:@selector(LLDragCollectionViewCell:canclefocus:)]) {
        [self.delegate LLDragCollectionViewCell:self canclefocus:sender];
    }
}
-(void)gestureAtion:(UIGestureRecognizer *)gesture{
    if (self.delegate && [self.delegate respondsToSelector:@selector(LLDragCollectionViewCell:gestureAction:)]) {
        [self.delegate  LLDragCollectionViewCell:self gestureAction:gesture];
    }
}
@end
